#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20070509

#define YYEMPTY (-1)
#define yyclearin    (yychar = YYEMPTY)
#define yyerrok      (yyerrflag = 0)
#define YYRECOVERING (yyerrflag != 0)

extern int yyparse(void);

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 2 "middle_lang.y"
/*
#! SELinux Policy Editor, a simple editor for SELinux policies
#! Copyright (C) 2003 Hitachi Software Engineering Co., Ltd.
#! Copyright (C) 2005, 2006 Yuichi Nakamura
#! 
#! This program is free software; you can redistribute it and/or modify
#! it under the terms of the GNU General Public License as published by
#! the Free Software Foundation; either version 2 of the License, or
#! (at your option) any later version.
#! 
#! This program is distributed in the hope that it will be useful,
#! but WITHOUT ANY WARRANTY; without even the implied warranty of
#! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#! GNU General Public License for more details.
#! 
#! You should have received a copy of the GNU General Public License
#! along with this program; if not, write to the Free Software
#! Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* $Id: middle_lang.y,v 1.20 2006/05/05 14:23:24 ynakam Exp $ */
/*yacc specification for middle language*/
/*Yuichi Nakamura fix after 2004 */
#include <stdio.h>
#include <seedit/parse.h>
#include <seedit/middle_lang.h>
#include <seedit/common.h>
#define YYSTYPE char *
static char **domains_list=NULL;
static char **paths_list=NULL;
static char **idents_list=NULL;
static char **string_list=NULL;
static char **port_list=NULL;
static char *name=NULL;
static char *option=NULL;
static int protocol;
static int behavior;
static int permission;
static int ipc_flag;

extern int yylex(void);

#line 66 "y.tab.c"
#define DOMAIN 257
#define ROLE 258
#define USER 259
#define ALL 260
#define ALLOW 261
#define ALLOWNET 262
#define ALLOWCOM 263
#define ALLOWADM 264
#define ALLOWDEV 265
#define ALLOWKEY 266
#define ALLOWFS 267
#define ALLOWTMP 268
#define ALLOWPRIV 269
#define DENYPRIV 270
#define ROOT 271
#define NAME 272
#define NET 273
#define RAW 274
#define NETLINK 275
#define CONNECT 276
#define FS 277
#define DIRECTORY 278
#define TCP 279
#define UDP 280
#define NETIFOPT 281
#define NODEOPT 282
#define PROTOCOLOPT 283
#define IPV4ADDRESS 284
#define SERVER 285
#define DEFAULT 286
#define CLIENT 287
#define USE 288
#define SEND 289
#define RECV 290
#define BIND 291
#define DOMAINOPT 292
#define ALLPORT 293
#define WELLKNOWN 294
#define UNPRIVPORT 295
#define UNIX 296
#define IPC 297
#define SEM 298
#define MSG 299
#define MSGQ 300
#define SHM 301
#define PIPE 302
#define SIG 303
#define PORT 304
#define SECURITY 305
#define SYSTEM 306
#define SELF 307
#define OTHER 308
#define KMSG 309
#define PROC 310
#define CREATE 311
#define CHANGE 312
#define GENERAL 313
#define DENY 314
#define DOMAIN_TRANS 315
#define PROGRAM 316
#define PATH 317
#define GLOBAL_DOMAIN 318
#define IDENTIFIER 319
#define FILENAME 320
#define NUMBER 321
#define EXCLUSIVE_FILE 322
#define TTY 323
#define PTS 324
#define ALLTERM 325
#define NOOWNER 326
#define OPEN 327
#define ADMIN 328
#define INCLUDE 329
#define INCLUDESTR 330
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    1,    1,    1,    1,    2,    2,
    2,    2,    6,    7,    7,    8,    3,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    9,    9,   17,
   17,   17,   17,   17,   17,   20,   19,   19,   19,   10,
    4,    4,    4,   21,   21,   22,   24,   24,   25,   25,
   25,   25,   23,   23,   11,   11,   11,   11,   11,   30,
   30,   30,   32,   32,   32,   32,   29,   29,   29,   29,
   29,   29,   29,   26,   26,   26,   26,   26,   28,   28,
   28,   28,   28,   31,   31,   31,   31,   33,   33,   33,
   33,   33,   33,   27,   27,   27,   27,   27,   34,   34,
   12,   12,   12,   12,   35,   35,   35,   35,   35,   35,
   35,   37,   37,   37,   18,   38,   38,   38,   13,   13,
   15,   15,   15,   15,   39,   39,   39,   40,   40,   40,
   14,   36,   36,   36,   16,   16,   16,
};
short yylen[] = {                                         2,
    2,    2,    1,    1,    5,    4,    3,    4,    6,    5,
    4,    5,    3,    2,    1,    3,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    4,    4,    6,
    7,    7,    6,    7,    7,    1,    3,    1,    1,    3,
    1,    2,    1,    4,    3,    3,    3,    1,    3,    3,
    1,    1,    3,    1,    7,    7,    5,    7,    7,    3,
    1,    1,    3,    3,    1,    1,    3,    3,    3,    1,
    1,    1,    1,    3,    3,    1,    1,    1,    3,    3,
    1,    1,    1,    3,    3,    1,    1,    3,    3,    3,
    1,    1,    1,    3,    1,    1,    1,    1,    1,    1,
    5,    5,    5,    5,    1,    1,    1,    1,    1,    1,
    1,    3,    1,    1,    4,    3,    1,    1,    3,    3,
    4,    5,    4,    5,    1,    1,    1,    1,    1,    1,
    4,    3,    1,    1,    3,    3,    3,
};
short yydefred[] = {                                      0,
    0,    0,    3,    4,    0,    0,    0,    0,    1,    2,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    7,    0,    0,   18,   19,
   20,   21,   22,   23,   24,   25,   26,   27,   51,   53,
    0,    0,    0,    0,   15,   17,   13,    0,    0,    0,
  115,  121,  116,  117,  118,  119,  120,    0,    0,    0,
  135,  136,  137,    0,   64,    0,    0,    0,    0,    0,
    0,    0,    0,   58,    0,    0,    0,    0,    8,    0,
   52,    6,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,    0,    0,   11,    0,    0,   14,   48,   46,
    0,   49,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   62,   61,    0,  140,  139,  138,    0,
    0,  127,    0,  128,    0,    0,    0,    0,    0,  129,
  130,   50,   55,    0,   56,    0,  146,  147,  145,    5,
   16,   10,    0,   12,   38,    0,   39,    0,    0,    0,
    0,    0,    0,  123,  124,    0,    0,  143,  144,    0,
    0,  131,    0,  133,    0,    0,   63,  125,    0,  141,
    0,    0,    0,   54,   57,    9,   47,   67,    0,  109,
  107,  108,  105,  110,    0,  106,   71,   72,    0,   75,
   76,    0,   79,    0,    0,  113,    0,  114,  111,    0,
  112,   60,   59,  134,  132,  126,    0,    0,    0,    0,
    0,   91,   92,    0,   93,    0,   96,   97,    0,    0,
    0,    0,  103,    0,    0,    0,  122,  142,    0,   43,
    0,   40,    0,    0,   65,  104,   66,    0,   70,   68,
    0,   73,   74,    0,   69,   45,   44,   41,   42,   89,
   90,   94,   95,    0,    0,  100,
};
short yydgoto[] = {                                       2,
    3,    4,    7,   27,   28,    8,   44,   45,   29,   30,
   31,   32,   33,   34,   35,   36,   37,   38,  101,  102,
   39,   40,   66,   75,  116,  108,  185,  216,  109,  189,
  220,  192,  226,  186,   59,  160,  156,  125,   64,  121,
};
short yysindex[] = {                                    -82,
 -117,  -82,    0,    0, -275, -271, -110,  204,    0,    0,
   24,   28, -106, -212,  140, -244, -226, -215, -128, -205,
 -195, -183, -226, -163, -182,    0,  -99,  -89,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -158,  220,  -79,  204,    0,    0,    0,  -35,  -35,  -33,
    0,    0,    0,    0,    0,    0,    0,  -34,  -32, -105,
    0,    0,    0, -188,    0,  -40,  -35,  -97, -142,  134,
  135,  144,  -25,    0,   -4,  159,  169,  172,    0,   60,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  175,   70,    0,  220,   82,    0,    0,    0,
    5,    0,    7,  -52,    0,    0,    0, -250,   -6,  -31,
  -31,  -30,  -30,    0,    0,    9,    0,    0,    0,  178,
  -42,    0,  -80,    0,   15,   17,  -24,  -21,  -15,    0,
    0,    0,    0,   19,    0,  -75,    0,    0,    0,    0,
    0,    0,   92,    0,    0,  -76,    0,  179, -226,  -41,
  -29,  -39,  -78,    0,    0,   26,   31,    0,    0,   44,
   47,    0,  -96,    0,  185,   50,    0,    0,  -70,    0,
  218,  -54,  -28,    0,    0,    0,    0,    0,  -20,    0,
    0,    0,    0,    0,  -13,    0,    0,    0,  -19,    0,
    0,  -27,    0,    0,    0,    0,  -46,    0,    0,  -18,
    0,    0,    0,    0,    0,    0,  -35,  -37,  -36,  -35,
  202,    0,    0,  -16,    0,   51,    0,    0,  -17,   56,
    0,    0,    0,  -60,  223,  244,    0,    0,   61,    0,
   63,    0,   64,   67,    0,    0,    0,  -58,    0,    0,
  -57,    0,    0,  -81,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   18,  -26,  -23,   12,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   14,   16,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   68,   69,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   73,   74,    0,
};
short yygindex[] = {                                      0,
  305,  307,    0,   29,   25,    0,    0,  266,   -8,    2,
    4,   22,   49,  291,  335,  351,  355,  367,  -10,  306,
    1,    0,   -7,  238,    0,    0,    0,    0,    0,    0,
  120,    0,    0,    0,    0,   23,  203,    0,    0,    0,
};
#define YYTABLESIZE 549
short yytable[] = {                                     100,
  100,  100,  100,  123,  100,  100,  100,  100,  100,  100,
  100,  100,  100,  100,   26,   73,  224,   80,  123,   83,
   81,  230,  232,  123,  219,   79,   60,   81,  100,   84,
  214,   85,   43,  133,   83,   82,   42,  153,  103,  136,
    1,  149,   81,   11,   84,   95,   85,   12,  146,   86,
  146,   80,  163,  150,  135,   83,  126,   77,  169,   78,
  146,   82,  136,  145,   86,  147,   94,  162,   97,  197,
   50,   83,   96,  168,  197,  170,   87,  174,   61,   62,
   63,   84,   46,   85,  196,   83,   47,  200,   83,  198,
  200,   87,   65,  200,  238,   84,   81,   85,   84,  241,
   85,   86,  199,   67,  146,  201,  146,  146,  205,  237,
  146,   96,   97,   70,  240,   86,   94,   95,   86,  246,
  143,  247,  248,   71,  117,  249,  101,  102,   87,  118,
  119,   98,   99,   72,   83,  161,   76,   77,  120,    5,
    6,  179,   87,  166,   84,   87,   85,   78,   68,   69,
   13,   14,   15,   74,   16,   17,   18,   19,   20,   21,
   93,   13,   14,   15,   86,   16,   17,   18,   19,   20,
   21,   13,   14,   15,  129,   16,   17,   18,   19,   20,
   21,   13,   14,   15,  140,   16,   17,   18,   19,   20,
   21,   87,  130,  131,  142,  193,  229,  231,  233,  234,
  194,  195,  132,   22,   23,   24,  144,  254,  255,  256,
   48,  114,   49,  115,   22,   23,  176,  137,   25,  127,
  202,  128,  203,  242,   22,  243,  250,  138,  251,   25,
  139,  252,  253,  141,   22,  148,  164,  178,  167,   25,
  104,  175,  177,  204,  190,  105,  106,  171,  206,   25,
  172,  180,  181,  182,   80,   80,  173,   81,   81,  100,
  235,  221,  222,  223,  208,   86,  244,  211,   87,  217,
  218,  212,  227,  213,  151,  152,  158,   86,  122,  183,
   87,   99,   99,   99,  110,  165,  112,  154,  158,  187,
  209,   74,   83,   83,   77,   77,   78,   78,   82,   82,
  228,  239,  245,   88,  236,   84,    9,   85,   10,   98,
  134,  225,    0,  157,    0,   88,    0,   84,   88,   85,
   13,   14,   15,    0,   16,   17,   18,   19,   20,   21,
   13,   14,   15,   88,   16,   17,   18,   19,   20,   21,
    0,    0,   13,   14,   15,    0,   16,   17,   18,   19,
   20,   21,   13,   14,   15,  107,   16,   17,   18,   19,
   20,   21,   89,  111,  113,    0,    0,    0,    0,    0,
   88,  124,    0,   22,    0,    0,    0,   89,   90,    0,
    0,    0,   91,   22,   88,    0,    0,   88,   25,    0,
    0,    0,    0,   90,   92,   22,    0,   91,   25,    0,
    0,    0,    0,    0,    0,   22,    0,    0,    0,   92,
   25,    0,    0,    0,   89,  155,  155,  159,  159,    0,
   25,    0,    0,    0,    0,    0,  159,    0,   89,    0,
   90,   89,    0,   88,   91,   51,   52,   53,   54,   55,
   56,   57,   58,    0,   90,    0,   92,   90,   91,    0,
    0,   91,    0,    0,    0,  184,  188,  191,    0,    0,
   92,    0,   41,   92,   13,   14,   15,    0,   16,   17,
   18,   19,   20,   21,    0,    0,  207,   89,  210,    0,
   13,   14,   15,    0,   16,   17,   18,   19,   20,   21,
  215,    0,    0,   90,    0,    0,    0,   91,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   92,
    0,    0,    0,    0,    0,    0,    0,   22,   23,   24,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   25,   22,   23,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   25,
};
short yycheck[] = {                                      42,
   42,   42,   42,   44,   42,   42,   42,   42,   42,   42,
   42,   42,   42,   42,  125,   23,   44,   44,   44,   28,
   44,   59,   59,   44,   44,  125,  271,   27,   42,   28,
   44,   28,    8,   59,   43,  125,    8,   44,   49,   44,
  123,  292,   42,  319,   43,  125,   43,  319,   44,   28,
   44,   27,   44,  304,   59,   44,   67,   44,   44,   44,
   44,   44,   44,   59,   43,   59,   42,   59,   44,   44,
  283,   80,   44,   59,   44,   59,   28,   59,  323,  324,
  325,   80,   59,   80,   59,   94,   59,   44,   97,   59,
   44,   43,  319,   44,   44,   94,   96,   94,   97,   44,
   97,   80,   59,  319,   44,   59,   44,   44,   59,   59,
   44,   44,   44,  319,   59,   94,   44,   44,   97,   59,
   96,   59,   59,  319,  313,   59,   59,   59,   80,  318,
  319,   59,   59,  317,  143,  113,  319,  320,  327,  257,
  258,  149,   94,  121,  143,   97,  143,  330,  277,  278,
  261,  262,  263,  317,  265,  266,  267,  268,  269,  270,
  319,  261,  262,  263,  143,  265,  266,  267,  268,  269,
  270,  261,  262,  263,  317,  265,  266,  267,  268,  269,
  270,  261,  262,  263,  125,  265,  266,  267,  268,  269,
  270,  143,   59,   59,  125,  274,  207,  208,  209,  210,
  279,  280,   59,  314,  315,  316,  125,  289,  290,  291,
  317,  317,  319,  319,  314,  315,  125,   59,  329,  317,
  317,  319,  319,  284,  314,  286,  285,   59,  287,  329,
   59,  289,  290,   59,  314,  288,   59,   59,  319,  329,
  274,  317,  319,   59,  284,  279,  280,  272,  319,  329,
  272,  293,  294,  295,  281,  282,  272,  281,  282,   42,
   59,  289,  290,  291,  319,  292,   44,  288,  292,  289,
  290,  285,  319,  287,  281,  282,  319,  304,  319,  321,
  304,  319,  319,  319,  319,  328,  319,  319,  319,  319,
  319,  317,  281,  282,  281,  282,  281,  282,  281,  282,
  319,  319,   59,  292,  321,  292,    2,  292,    2,   44,
   73,  192,   -1,  111,   -1,  304,   -1,  304,   28,  304,
  261,  262,  263,   -1,  265,  266,  267,  268,  269,  270,
  261,  262,  263,   43,  265,  266,  267,  268,  269,  270,
   -1,   -1,  261,  262,  263,   -1,  265,  266,  267,  268,
  269,  270,  261,  262,  263,   50,  265,  266,  267,  268,
  269,  270,   28,   58,   59,   -1,   -1,   -1,   -1,   -1,
   80,   66,   -1,  314,   -1,   -1,   -1,   43,   28,   -1,
   -1,   -1,   28,  314,   94,   -1,   -1,   97,  329,   -1,
   -1,   -1,   -1,   43,   28,  314,   -1,   43,  329,   -1,
   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,   -1,   43,
  329,   -1,   -1,   -1,   80,  110,  111,  112,  113,   -1,
  329,   -1,   -1,   -1,   -1,   -1,  121,   -1,   94,   -1,
   80,   97,   -1,  143,   80,  296,  297,  298,  299,  300,
  301,  302,  303,   -1,   94,   -1,   80,   97,   94,   -1,
   -1,   97,   -1,   -1,   -1,  150,  151,  152,   -1,   -1,
   94,   -1,  259,   97,  261,  262,  263,   -1,  265,  266,
  267,  268,  269,  270,   -1,   -1,  171,  143,  173,   -1,
  261,  262,  263,   -1,  265,  266,  267,  268,  269,  270,
  185,   -1,   -1,  143,   -1,   -1,   -1,  143,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  143,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,  315,  316,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  329,  314,  315,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  329,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 330
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'*'",0,"','",0,0,0,0,0,0,0,0,0,0,0,0,0,0,"';'",0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"DOMAIN",
"ROLE","USER","ALL","ALLOW","ALLOWNET","ALLOWCOM","ALLOWADM","ALLOWDEV",
"ALLOWKEY","ALLOWFS","ALLOWTMP","ALLOWPRIV","DENYPRIV","ROOT","NAME","NET",
"RAW","NETLINK","CONNECT","FS","DIRECTORY","TCP","UDP","NETIFOPT","NODEOPT",
"PROTOCOLOPT","IPV4ADDRESS","SERVER","DEFAULT","CLIENT","USE","SEND","RECV",
"BIND","DOMAINOPT","ALLPORT","WELLKNOWN","UNPRIVPORT","UNIX","IPC","SEM","MSG",
"MSGQ","SHM","PIPE","SIG","PORT","SECURITY","SYSTEM","SELF","OTHER","KMSG",
"PROC","CREATE","CHANGE","GENERAL","DENY","DOMAIN_TRANS","PROGRAM","PATH",
"GLOBAL_DOMAIN","IDENTIFIER","FILENAME","NUMBER","EXCLUSIVE_FILE","TTY","PTS",
"ALLTERM","NOOWNER","OPEN","ADMIN","INCLUDE","INCLUDESTR",
};
char *yyrule[] = {
"$accept : POLICY",
"POLICY : POLICY TE_SECTION",
"POLICY : POLICY RBAC_SECTION",
"POLICY : TE_SECTION",
"POLICY : RBAC_SECTION",
"TE_SECTION : '{' DOMAIN_DEF DOMAIN_TRANS_DEFS BODY_DEFS '}'",
"TE_SECTION : '{' DOMAIN_DEF BODY_DEFS '}'",
"TE_SECTION : '{' DOMAIN_DEF '}'",
"TE_SECTION : '{' DOMAIN_DEF DOMAIN_TRANS_DEFS '}'",
"RBAC_SECTION : '{' ROLE_DEF USER_DEFS DOMAIN_TRANS_DEFS BODY_DEFS '}'",
"RBAC_SECTION : '{' ROLE_DEF DOMAIN_TRANS_DEFS BODY_DEFS '}'",
"RBAC_SECTION : '{' ROLE_DEF BODY_DEFS '}'",
"RBAC_SECTION : '{' ROLE_DEF USER_DEFS BODY_DEFS '}'",
"ROLE_DEF : ROLE IDENTIFIER ';'",
"USER_DEFS : USER_DEFS USER_DEF",
"USER_DEFS : USER_DEF",
"USER_DEF : USER IDENTIFIER ';'",
"DOMAIN_DEF : DOMAIN IDENTIFIER ';'",
"BODY_DEFS : ALLOW_DEF",
"BODY_DEFS : DENY_DEF",
"BODY_DEFS : ALLOWNET_DEF",
"BODY_DEFS : ALLOWCOM_DEF",
"BODY_DEFS : ALLOWPRIV_DEF",
"BODY_DEFS : ALLOWFS_DEF",
"BODY_DEFS : ALLOWDEV_DEF",
"BODY_DEFS : INCLUDE_DEF",
"BODY_DEFS : ALLOWTMP_DEF",
"BODY_DEFS : ALLOWKEY_DEF",
"BODY_DEFS : BODY_DEFS ALLOW_DEF",
"BODY_DEFS : BODY_DEFS DENY_DEF",
"BODY_DEFS : BODY_DEFS ALLOWNET_DEF",
"BODY_DEFS : BODY_DEFS ALLOWCOM_DEF",
"BODY_DEFS : BODY_DEFS ALLOWPRIV_DEF",
"BODY_DEFS : BODY_DEFS ALLOWFS_DEF",
"BODY_DEFS : BODY_DEFS ALLOWDEV_DEF",
"BODY_DEFS : BODY_DEFS INCLUDE_DEF",
"BODY_DEFS : BODY_DEFS ALLOWTMP_DEF",
"BODY_DEFS : BODY_DEFS ALLOWKEY_DEF",
"ALLOW_DEF : ALLOW PATH PERMISSIONS ';'",
"ALLOW_DEF : ALLOW IDENTIFIER PERMISSIONS ';'",
"ALLOWTMP_DEF : ALLOWTMP DIRECTORY PATH NAME IDENTIFIER ';'",
"ALLOWTMP_DEF : ALLOWTMP DIRECTORY PATH NAME IDENTIFIER PERMISSIONS ';'",
"ALLOWTMP_DEF : ALLOWTMP DIRECTORY PATH NAME ASTERISK PERMISSIONS ';'",
"ALLOWTMP_DEF : ALLOWTMP FS IDENTIFIER NAME IDENTIFIER ';'",
"ALLOWTMP_DEF : ALLOWTMP FS IDENTIFIER NAME IDENTIFIER PERMISSIONS ';'",
"ALLOWTMP_DEF : ALLOWTMP FS PATH NAME ASTERISK PERMISSIONS ';'",
"ASTERISK : '*'",
"PERMISSIONS : PERMISSIONS ',' IDENTIFIER",
"PERMISSIONS : IDENTIFIER",
"PERMISSIONS : ASTERISK",
"DENY_DEF : DENY PATH ';'",
"DOMAIN_TRANS_DEFS : DOMAIN_TRANS_DEF",
"DOMAIN_TRANS_DEFS : DOMAIN_TRANS_DEFS DOMAIN_TRANS_DEF",
"DOMAIN_TRANS_DEFS : PROGRAM_DEF",
"DOMAIN_TRANS_DEF : DOMAIN_TRANS DOMAINS_DEF PATHS_DEF ';'",
"DOMAIN_TRANS_DEF : DOMAIN_TRANS DOMAINS_DEF ';'",
"PROGRAM_DEF : PROGRAM PATHS_DEF ';'",
"PATHS_DEF : PATHS_DEF ',' PATH",
"PATHS_DEF : PATH",
"IDENTIFIER_PATHS_DEF : IDENTIFIER_PATHS_DEF ',' IDENTIFIER",
"IDENTIFIER_PATHS_DEF : IDENTIFIER_PATHS_DEF ',' PATH",
"IDENTIFIER_PATHS_DEF : IDENTIFIER",
"IDENTIFIER_PATHS_DEF : PATH",
"DOMAINS_DEF : DOMAINS_DEF ',' IDENTIFIER",
"DOMAINS_DEF : IDENTIFIER",
"ALLOWNET_DEF : ALLOWNET PROTOCOLOPT TCPUDP_DEF DOMAINOPT DOMAINS_DEF USE ';'",
"ALLOWNET_DEF : ALLOWNET PROTOCOLOPT TCPUDP_DEF PORT PORT_DEF PORT_PERM_DEF ';'",
"ALLOWNET_DEF : ALLOWNET PROTOCOLOPT RAW USE ';'",
"ALLOWNET_DEF : ALLOWNET PROTOCOLOPT PROTOCOL_DEF NETIFOPT IDENTIFIER_LIST_DEF SEND_RECV_PERM_DEF ';'",
"ALLOWNET_DEF : ALLOWNET PROTOCOLOPT PROTOCOL_DEF NODEOPT IPV4ADDRESS_LIST_DEF SEND_RECV_BIND_PERM_DEF ';'",
"IDENTIFIER_LIST_DEF : IDENTIFIER_LIST_DEF ',' IDENTIFIER",
"IDENTIFIER_LIST_DEF : IDENTIFIER",
"IDENTIFIER_LIST_DEF : ASTERISK",
"IPV4ADDRESS_LIST_DEF : IPV4ADDRESS_LIST_DEF ',' IPV4ADDRESS",
"IPV4ADDRESS_LIST_DEF : IPV4ADDRESS_LIST_DEF ',' DEFAULT",
"IPV4ADDRESS_LIST_DEF : IPV4ADDRESS",
"IPV4ADDRESS_LIST_DEF : ASTERISK",
"PROTOCOL_DEF : PROTOCOL_DEF ',' TCP",
"PROTOCOL_DEF : PROTOCOL_DEF ',' UDP",
"PROTOCOL_DEF : PROTOCOL_DEF ',' RAW",
"PROTOCOL_DEF : TCP",
"PROTOCOL_DEF : UDP",
"PROTOCOL_DEF : RAW",
"PROTOCOL_DEF : ASTERISK",
"TCPUDP_DEF : PROTOCOL_DEF ',' TCP",
"TCPUDP_DEF : PROTOCOL_DEF ',' UDP",
"TCPUDP_DEF : TCP",
"TCPUDP_DEF : UDP",
"TCPUDP_DEF : ASTERISK",
"PORT_PERM_DEF : PORT_PERM_DEF ',' SERVER",
"PORT_PERM_DEF : PORT_PERM_DEF ',' CLIENT",
"PORT_PERM_DEF : SERVER",
"PORT_PERM_DEF : CLIENT",
"PORT_PERM_DEF : ASTERISK",
"SEND_RECV_PERM_DEF : SEND_RECV_PERM_DEF ',' SEND",
"SEND_RECV_PERM_DEF : SEND_RECV_PERM_DEF ',' RECV",
"SEND_RECV_PERM_DEF : SEND",
"SEND_RECV_PERM_DEF : RECV",
"SEND_RECV_BIND_PERM_DEF : SEND_RECV_PERM_DEF ',' SEND",
"SEND_RECV_BIND_PERM_DEF : SEND_RECV_PERM_DEF ',' RECV",
"SEND_RECV_BIND_PERM_DEF : SEND_RECV_PERM_DEF ',' BIND",
"SEND_RECV_BIND_PERM_DEF : SEND",
"SEND_RECV_BIND_PERM_DEF : RECV",
"SEND_RECV_BIND_PERM_DEF : BIND",
"PORT_DEF : PORT_DEF ',' NUMBER",
"PORT_DEF : NUMBER",
"PORT_DEF : ALLPORT_DEF",
"PORT_DEF : WELLKNOWN",
"PORT_DEF : UNPRIVPORT",
"ALLPORT_DEF : ALLPORT",
"ALLPORT_DEF : ASTERISK",
"ALLOWCOM_DEF : ALLOWCOM IPC_OPT IDENTIFIER READ_WRITE_PERMISSIONS ';'",
"ALLOWCOM_DEF : ALLOWCOM IPC_OPT ASTERISK READ_WRITE_PERMISSIONS ';'",
"ALLOWCOM_DEF : ALLOWCOM SIG IDENTIFIER SIG_PERMISSIONS ';'",
"ALLOWCOM_DEF : ALLOWCOM SIG ASTERISK SIG_PERMISSIONS ';'",
"IPC_OPT : UNIX",
"IPC_OPT : SEM",
"IPC_OPT : MSG",
"IPC_OPT : MSGQ",
"IPC_OPT : SHM",
"IPC_OPT : PIPE",
"IPC_OPT : IPC",
"SIG_PERMISSIONS : SIG_PERMISSIONS ',' IDENTIFIER",
"SIG_PERMISSIONS : IDENTIFIER",
"SIG_PERMISSIONS : ASTERISK",
"ALLOWKEY_DEF : ALLOWKEY DOMAINS_DEF KEY_PERMISSIONS ';'",
"KEY_PERMISSIONS : KEY_PERMISSIONS ',' IDENTIFIER",
"KEY_PERMISSIONS : IDENTIFIER",
"KEY_PERMISSIONS : ASTERISK",
"ALLOWPRIV_DEF : ALLOWPRIV IDENTIFIER ';'",
"ALLOWPRIV_DEF : DENYPRIV IDENTIFIER ';'",
"ALLOWDEV_DEF : ALLOWDEV ROOT IDENTIFIER_PATHS_DEF ';'",
"ALLOWDEV_DEF : ALLOWDEV DEVOPT_DEF NAME_DEF READ_WRITE_PERMISSIONS ';'",
"ALLOWDEV_DEF : ALLOWDEV DEVOPT_DEF OPEN ';'",
"ALLOWDEV_DEF : ALLOWDEV DEVOPT_DEF NAME_DEF ADMIN ';'",
"DEVOPT_DEF : TTY",
"DEVOPT_DEF : PTS",
"DEVOPT_DEF : ALLTERM",
"NAME_DEF : IDENTIFIER",
"NAME_DEF : GLOBAL_DOMAIN",
"NAME_DEF : GENERAL",
"ALLOWFS_DEF : ALLOWFS IDENTIFIER PERMISSIONS ';'",
"READ_WRITE_PERMISSIONS : READ_WRITE_PERMISSIONS ',' IDENTIFIER",
"READ_WRITE_PERMISSIONS : IDENTIFIER",
"READ_WRITE_PERMISSIONS : ASTERISK",
"INCLUDE_DEF : INCLUDE INCLUDESTR ';'",
"INCLUDE_DEF : INCLUDE IDENTIFIER ';'",
"INCLUDE_DEF : INCLUDE FILENAME ';'",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static int      yystacksize;
#line 392 "middle_lang.y"

#line 600 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse(void)
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

#ifdef lint
    goto yyerrlab;
#endif

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 13:
#line 146 "middle_lang.y"
{register_role(yyvsp[-1]);}
break;
case 16:
#line 153 "middle_lang.y"
{register_user(yyvsp[-1]);}
break;
case 17:
#line 157 "middle_lang.y"
{register_domain(yyvsp[-1],0); }
break;
case 38:
#line 173 "middle_lang.y"
{register_file_rule(yyvsp[-2]);}
break;
case 39:
#line 174 "middle_lang.y"
{register_file_rule(yyvsp[-2]);}
break;
case 40:
#line 177 "middle_lang.y"
{register_tmp_file_acl(yyvsp[-3],yyvsp[-1],0);}
break;
case 41:
#line 178 "middle_lang.y"
{ register_tmp_file_acl(yyvsp[-4],yyvsp[-2],1);}
break;
case 42:
#line 179 "middle_lang.y"
{  register_tmp_file_acl(yyvsp[-4],yyvsp[-2],1); }
break;
case 43:
#line 180 "middle_lang.y"
{ register_tmp_fs_acl(yyvsp[-3],yyvsp[-1],0);}
break;
case 44:
#line 181 "middle_lang.y"
{ register_tmp_fs_acl(yyvsp[-4],yyvsp[-2],1);}
break;
case 45:
#line 182 "middle_lang.y"
{  register_tmp_file_acl(yyvsp[-4],yyvsp[-2],1); }
break;
case 47:
#line 189 "middle_lang.y"
{add_permission(yyvsp[0],FILE_PERM,0);}
break;
case 48:
#line 190 "middle_lang.y"
{ add_permission(yyvsp[0],FILE_PERM,1); }
break;
case 49:
#line 191 "middle_lang.y"
{ add_permission(yyvsp[0],FILE_PERM,1);}
break;
case 50:
#line 198 "middle_lang.y"
{register_file_deny(yyvsp[-1]);}
break;
case 54:
#line 208 "middle_lang.y"
{register_domain_trans(domains_list,paths_list);}
break;
case 55:
#line 209 "middle_lang.y"
{register_domain_trans(domains_list,NULL);}
break;
case 56:
#line 213 "middle_lang.y"
{register_program(paths_list,0);}
break;
case 57:
#line 220 "middle_lang.y"
{ paths_list = add_strlist(paths_list,yyvsp[0],0); }
break;
case 58:
#line 221 "middle_lang.y"
{ paths_list = add_strlist(paths_list,yyvsp[0],1); }
break;
case 59:
#line 225 "middle_lang.y"
{ idents_list = add_strlist(idents_list,yyvsp[0],0); }
break;
case 60:
#line 226 "middle_lang.y"
{ idents_list = add_strlist(idents_list,yyvsp[0],0); }
break;
case 61:
#line 227 "middle_lang.y"
{ idents_list = add_strlist(idents_list,yyvsp[0],1); }
break;
case 62:
#line 228 "middle_lang.y"
{ idents_list = add_strlist(idents_list,yyvsp[0],1); }
break;
case 63:
#line 234 "middle_lang.y"
{ domains_list = add_strlist(domains_list,yyvsp[0],0);}
break;
case 64:
#line 235 "middle_lang.y"
{ domains_list = add_strlist(domains_list,yyvsp[0],1); }
break;
case 65:
#line 241 "middle_lang.y"
{register_net_sock_acl(ALLOW_RULE, protocol,NET_USE, NULL,domains_list);}
break;
case 66:
#line 243 "middle_lang.y"
{register_net_sock_acl(ALLOW_RULE, protocol,behavior,port_list,NULL);}
break;
case 67:
#line 245 "middle_lang.y"
{ 
domains_list = add_strlist(domains_list,"domain",1);  
register_net_sock_acl(ALLOW_RULE, NET_RAW,NET_USE,NULL, domains_list);  
}
break;
case 68:
#line 251 "middle_lang.y"
{register_net_netif_acl(ALLOW_RULE, protocol,string_list,permission);}
break;
case 69:
#line 253 "middle_lang.y"
{register_net_node_acl(ALLOW_RULE, protocol,string_list,permission);}
break;
case 70:
#line 256 "middle_lang.y"
{ string_list = add_strlist(string_list,yyvsp[0],0);}
break;
case 71:
#line 257 "middle_lang.y"
{ string_list = add_strlist(string_list,yyvsp[0],1); }
break;
case 72:
#line 258 "middle_lang.y"
{ string_list = add_strlist(string_list,"*",1); }
break;
case 73:
#line 261 "middle_lang.y"
{string_list = add_strlist(string_list, yyvsp[0],0);}
break;
case 74:
#line 262 "middle_lang.y"
{string_list = add_strlist(string_list, yyvsp[0],0);}
break;
case 75:
#line 263 "middle_lang.y"
{string_list = add_strlist(string_list,yyvsp[0],1);}
break;
case 76:
#line 264 "middle_lang.y"
{string_list = add_strlist(string_list, "*" ,1);}
break;
case 77:
#line 267 "middle_lang.y"
{protocol|=NET_TCP;}
break;
case 78:
#line 268 "middle_lang.y"
{protocol|=NET_UDP;}
break;
case 79:
#line 269 "middle_lang.y"
{protocol|=NET_RAW;}
break;
case 80:
#line 270 "middle_lang.y"
{protocol=NET_TCP;}
break;
case 81:
#line 271 "middle_lang.y"
{protocol=NET_UDP;}
break;
case 82:
#line 272 "middle_lang.y"
{protocol=NET_RAW;}
break;
case 83:
#line 273 "middle_lang.y"
{protocol = NET_TCP|NET_UDP|NET_RAW;}
break;
case 84:
#line 276 "middle_lang.y"
{protocol|=NET_TCP;}
break;
case 85:
#line 277 "middle_lang.y"
{protocol|=NET_UDP;}
break;
case 86:
#line 278 "middle_lang.y"
{protocol=NET_TCP;}
break;
case 87:
#line 279 "middle_lang.y"
{protocol=NET_UDP;}
break;
case 88:
#line 280 "middle_lang.y"
{protocol = NET_TCP|NET_UDP;}
break;
case 89:
#line 284 "middle_lang.y"
{behavior|=NET_SERVER;}
break;
case 90:
#line 285 "middle_lang.y"
{behavior|=NET_CLIENT;}
break;
case 91:
#line 286 "middle_lang.y"
{behavior=NET_SERVER;}
break;
case 92:
#line 287 "middle_lang.y"
{behavior=NET_CLIENT;}
break;
case 93:
#line 288 "middle_lang.y"
{behavior = NET_SERVER|NET_CLIENT;}
break;
case 94:
#line 293 "middle_lang.y"
{permission|=NET_SEND;}
break;
case 95:
#line 294 "middle_lang.y"
{permission |=NET_RECV;}
break;
case 96:
#line 295 "middle_lang.y"
{permission =NET_SEND;}
break;
case 97:
#line 296 "middle_lang.y"
{permission =NET_RECV;}
break;
case 98:
#line 299 "middle_lang.y"
{permission|=NET_SEND;}
break;
case 99:
#line 300 "middle_lang.y"
{permission |=NET_RECV;}
break;
case 100:
#line 301 "middle_lang.y"
{permission |=NET_BIND;}
break;
case 101:
#line 302 "middle_lang.y"
{permission =NET_SEND;}
break;
case 102:
#line 303 "middle_lang.y"
{permission =NET_RECV;}
break;
case 103:
#line 304 "middle_lang.y"
{permission =NET_BIND;}
break;
case 104:
#line 310 "middle_lang.y"
{port_list = add_strlist(port_list,yyvsp[0],0);}
break;
case 105:
#line 311 "middle_lang.y"
{ port_list = add_strlist(port_list,yyvsp[0],1);}
break;
case 106:
#line 312 "middle_lang.y"
{ port_list = add_strlist(port_list,PORT_ALL,1);}
break;
case 107:
#line 313 "middle_lang.y"
{ port_list = add_strlist(port_list,PORT_WELLKNOWN,1);}
break;
case 108:
#line 314 "middle_lang.y"
{ port_list = add_strlist(port_list,PORT_UNPRIV,1);}
break;
case 109:
#line 317 "middle_lang.y"
{;}
break;
case 110:
#line 318 "middle_lang.y"
{;}
break;
case 111:
#line 323 "middle_lang.y"
{register_com_acl(ipc_flag,yyvsp[-2]);}
break;
case 112:
#line 324 "middle_lang.y"
{register_com_acl(ipc_flag,yyvsp[-2]);}
break;
case 113:
#line 325 "middle_lang.y"
{register_com_acl(SIG_ACL,yyvsp[-2]);}
break;
case 114:
#line 326 "middle_lang.y"
{register_com_acl(SIG_ACL,yyvsp[-2]);}
break;
case 115:
#line 329 "middle_lang.y"
{ipc_flag = UNIX_ACL;}
break;
case 116:
#line 330 "middle_lang.y"
{ipc_flag = SEM_ACL;}
break;
case 117:
#line 331 "middle_lang.y"
{ipc_flag = MSG_ACL;}
break;
case 118:
#line 332 "middle_lang.y"
{ipc_flag = MSGQ_ACL;}
break;
case 119:
#line 333 "middle_lang.y"
{ipc_flag = SHM_ACL;}
break;
case 120:
#line 334 "middle_lang.y"
{ipc_flag = PIPE_ACL;}
break;
case 121:
#line 335 "middle_lang.y"
{ipc_flag = UNIX_ACL|SEM_ACL|MSG_ACL|MSGQ_ACL|SHM_ACL|PIPE_ACL;}
break;
case 122:
#line 338 "middle_lang.y"
{add_permission(yyvsp[0],SIG_PERM,0);}
break;
case 123:
#line 339 "middle_lang.y"
{ add_permission(yyvsp[0],SIG_PERM,1); }
break;
case 124:
#line 340 "middle_lang.y"
{ add_permission(yyvsp[0], SIG_PERM, 1); }
break;
case 125:
#line 344 "middle_lang.y"
{register_key_acl(domains_list);}
break;
case 126:
#line 347 "middle_lang.y"
{add_permission(yyvsp[0],KEY_PERM,0);}
break;
case 127:
#line 348 "middle_lang.y"
{ add_permission(yyvsp[0],KEY_PERM,1); }
break;
case 128:
#line 349 "middle_lang.y"
{ add_permission(yyvsp[0], KEY_PERM, 1); }
break;
case 129:
#line 354 "middle_lang.y"
{register_admin_other_acl(yyvsp[-1],0);}
break;
case 130:
#line 355 "middle_lang.y"
{register_admin_other_acl(yyvsp[-1],1);}
break;
case 131:
#line 359 "middle_lang.y"
{register_dev_acl(idents_list);}
break;
case 132:
#line 360 "middle_lang.y"
{register_terminal_acl(option,name,2);}
break;
case 133:
#line 361 "middle_lang.y"
{register_terminal_acl(option,NULL,0);}
break;
case 134:
#line 362 "middle_lang.y"
{register_terminal_acl(option,name,1);}
break;
case 135:
#line 365 "middle_lang.y"
{ option = alloc_str(yyvsp[0],option);}
break;
case 136:
#line 366 "middle_lang.y"
{ option = alloc_str(yyvsp[0],option); }
break;
case 137:
#line 367 "middle_lang.y"
{ option = alloc_str(yyvsp[0],option);}
break;
case 138:
#line 369 "middle_lang.y"
{  name = alloc_str(yyvsp[0],name);}
break;
case 139:
#line 370 "middle_lang.y"
{ name = alloc_str(yyvsp[0],name);}
break;
case 140:
#line 371 "middle_lang.y"
{ name = alloc_str(yyvsp[0],name);}
break;
case 141:
#line 375 "middle_lang.y"
{register_fs_acl(yyvsp[-2]);}
break;
case 142:
#line 379 "middle_lang.y"
{add_permission(yyvsp[0],RW_PERM,0);}
break;
case 143:
#line 380 "middle_lang.y"
{ add_permission(yyvsp[0],RW_PERM,1); }
break;
case 144:
#line 381 "middle_lang.y"
{ add_permission(yyvsp[0], RW_PERM,1);}
break;
case 145:
#line 384 "middle_lang.y"
{include_rule(yyvsp[-1]);}
break;
case 146:
#line 385 "middle_lang.y"
{include_rule(yyvsp[-1]);}
break;
case 147:
#line 386 "middle_lang.y"
{include_rule(yyvsp[-1]);}
break;
#line 1220 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
